000010*@M	       MAIN
000020 IDENTIFICATION DIVISION.
000030 PROGRAM-ID. PRINTEST.
000040 DATE-COMPILED.
000050* ------------------------: Demos Several Print APIs
000060* 			:   1) Printer Dialog box
000070* 			:   2) Basic printing APIs (7 in all)
000080* 			:   3) PrintFile API
000090* 			:
000100*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000110 ENVIRONMENT DIVISION.
000120*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000130 CONFIGURATION SECTION.
000140 SOURCE-COMPUTER. IBM-PC.
000150 OBJECT-COMPUTER. IBM-PC.
000160*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000170 DATA DIVISION.
000180*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000190 WORKING-STORAGE SECTION.
000200 01  V--VERSION-LEVEL		    PIC 9(3) VALUE 4.
000210 01  PROGRAM-NAME 		    PIC X(8) VALUE 'PRINTEST'.
000220*
000230* 			: Copy the panels for the TEST
000240	       COPY TESTMAIN.
000250	       COPY TESTPRT.
000260* 			: Copybooks for the APIs
000270	       COPY OPENSAVE.
000280	       COPY PRINTDLG.
000290	       COPY PRINTAPI.
000300	       COPY PRTFILE.
000310	       COPY WIN32API.
000320	       COPY GSPRTDEF.
000330 01  WS-OPERATION-NAME		    PIC X(30).
000340* -====-
000350 01  STUFF-TO-PRINT.
000360	   05  FILLER			    PIC X(48) VALUE
000370		     'This is the meat and potatos of the document we '.
000380	   05  FILLER			    PIC X(2) VALUE X'0D0A'.
000390	   05  FILLER			    PIC X(48) VALUE
000400		     'test with. It has some salad and beverage tossed'.
000410	   05  FILLER			    PIC X(2) VALUE X'0D0A'.
000420	   05  FILLER			    PIC X(48) VALUE
000430		      'in for the fun of it.                          '.
000440	   05  FILLER			    PIC X(2) VALUE X'0D0A'.
000450	   05  FILLER			    PIC X(2) VALUE X'0D0A'.
000460	   05  FILLER			    PIC X(48) VALUE
000470		     'After that gap here is some more text. Now Eject'.
000480	   05  FILLER			    PIC X VALUE X'0C'.
000490*
000500 01  STRGPTR			    PIC S9(4) COMP-5.
000510* -====-
000520 01  HPCL-LASERJET-ESC-CODES.
000530	   05  PORTRAIT 		    PIC X(5) VALUE X'1B' &
000540								 '&l0O'.
000550	   05  LANDSCAPE		    PIC X(5) VALUE X'1B' &
000560								 '&l1O'.
000570	   05  6-LPI			    PIC X(5) VALUE X'1B' &
000580								 '&l6D'.
000590	   05  8-LPI			    PIC X(5) VALUE X'1B' &
000600								 '&l8D'.
000610	   05  COURIER-12		    PIC x(21) VALUE X'1B' &
000620								 '(0U' &
000630								 X'1B' &
000640						     '(s0p10h12v0s0b3T'.
000650	   05  HELVITICA-14		    PIC X(23) VALUE X'1B' &
000660								 '(0U' &
000670								 X'1B' &
000680						   '(s0p10h14.4v0s0b4T'.
000690	   05  LINEPRINTER-16		    PIC X(24) VALUE X'1B' &
000700								 '(0U' &
000710								 X'1B' &
000720						  '(s0p16.6h8.5v0s0b0T'.
000730	   05  RESET-STRING		    pic X(2) VALUE x'1B' & 'E'.
000740*
000750*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000760 PROCEDURE DIVISION.
000770*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000780*
000790	   PERFORM 0102-INITIALIZE-GS.
000800	   SET PRTDLG-NO-PRINTER-PRESELECTION TO TRUE
000810*
000820* ------------------------: Display the test panel.
000830*
000840	   PERFORM WITH TEST AFTER
000850		 UNTIL TESTPRT-EVENT-CLOSE-AND-STOP
000860		 OR TESTPRT-CANCEL
000870*
000880	     CALL 'GS' USING TESTPRT-1
000890			     TESTPRT-2
000900			     TESTPRT-3
000910			     TESTPRT-4
000920	     EVALUATE TRUE
000930*
000940* 			:---------------------------------------
000950* ------------------------: Demo the use of the Print Dialog box
000960* 			:---------------------------------------
000970	       WHEN TESTPRT-LANUCH OR TESTPRT-LAUNCH-PROP
000980		 MOVE TESTPRT-HWND TO PRTDLG-HWNDOWNER
000990		 SET PRTDLG-PAGES-UNKNOWN TO TRUE
001000		 ADD
001010		     PRTF-ALLPAGES
001020		     PRTF-USEDEVMODECOPIES
001030		     GIVING PRTDLG-FLAGS
001040* 			: This makes a differnce on win2k/xp
001050		 IF TESTPRT-LAUNCH-PROP
001060		   ADD PRTF-PRINTSETUP TO PRTDLG-FLAGS
001070		 END-IF
001080		 SET API-PRINTDIALOG TO TRUE
001090		 CALL 'GSWINAPI' USING WIN32API-PARMS
001100				       PRINTDIALOG-PARMS
001110				       GS-DEVMODE-DATA
001120				       WIN32API-C
001130				       WIN32API-D
001140				       WIN32API-E
001150				       WIN32API-F
001160		 MOVE "Printer Dialog API " TO WS-OPERATION-NAME
001170		 PERFORM 0101-DIAGNOSE-CALL
001180		 SET TESTPRT-MESSAGE-BAR-SILENT TO TRUE
001190		 MOVE PRTDLG-PRINTER-PORT-NAME
001200		     TO P-PORT
001210		 MOVE PRTDLG-PRINTER-NAME
001220		     TO P-DEVICE
001230		 MOVE PRTDLG-PRINTER-DEVICE-DRIVER
001240		     TO P-DRIVER-NAME
001250		 MOVE PRTDLG-HDC TO P-HDC
001260*
001270* 			:---------------------------------------
001280* ------------------------: Print a page of simple text using
001290* 			: the low-level routines
001300* 			:---------------------------------------
001310	       WHEN TESTPRT-PRINTTOIT
001320* 			: See if we have a printer name or
001330* 			: if we are supposed to fetch it
001340		 IF P-DEVICE > SPACE
001350		   MOVE P-DEVICE TO PRINTAPI-OPENPRINTER-NAME
001360		   MOVE LOW-VALUE TO PRINTAPI-DIALOG-HWND
001370		 ELSE
001380		   MOVE LOW-VALUES TO PRINTAPI-OPENPRINTER-NAME
001390		   MOVE TESTPRT-HWND TO PRINTAPI-DIALOG-HWND
001400		 END-IF
001410		 SET API-OPENPRINTER TO TRUE
001420		 CALL 'GSWINAPI' USING WIN32API-PARMS
001430				       PRINTAPI-HANDLE
001440				       PRINTAPI-OPENPRINTER-DATA
001450				       GS-DEVMODE-DATA
001460				       WIN32API-D
001470				       WIN32API-E
001480				       WIN32API-F
001490		 MOVE "Open Printer API " TO WS-OPERATION-NAME
001500		 PERFORM 0101-DIAGNOSE-CALL
001510*
001520		 IF NOT WIN32API-FAILED
001530		   MOVE PRINTAPI-OPENPRINTER-NAME TO P-DEVICE
001540		   MOVE PRINTAPI-HANDLE TO P-HANDLE
001550*
001560		   MOVE 'GUI ScreenIO test print'
001570		       TO PRINTAPI-STARTDOC-NAME
001580		   SET PRINTAPI-DATA-RAW TO TRUE
001590		   SET API-STARTDOCPRINTER TO TRUE
001600		   CALL 'GSWINAPI' USING WIN32API-PARMS
001610					 PRINTAPI-HANDLE
001620					 PRINTAPI-STARTDOC-DATA
001630					 WIN32API-C
001640					 WIN32API-D
001650					 WIN32API-E
001660					 WIN32API-F
001670*
001680		   MOVE "Start Doc Printer API " TO WS-OPERATION-NAME
001690		   PERFORM 0101-DIAGNOSE-CALL
001700*
001710		   IF NOT WIN32API-FAILED
001720		     SET API-STARTPAGEPRINTER TO TRUE
001730		     CALL 'GSWINAPI' USING WIN32API-PARMS
001740					   PRINTAPI-HANDLE
001750					   WIN32API-B
001760					   WIN32API-C
001770					   WIN32API-D
001780					   WIN32API-E
001790					   WIN32API-F
001800*
001810		     MOVE "Start Page Printer API " TO WS-OPERATION-NAME
001820		     PERFORM 0101-DIAGNOSE-CALL
001830*
001840		     IF NOT WIN32API-FAILED
001850		       MOVE LENGTH OF STUFF-TO-PRINT TO
001860			   PRINTAPI-WRITEPRINTER-SIZE
001870		       MOVE ZERO TO PRINTAPI-WRITEPRINTER-WRITTEN
001880		       SET API-WRITEPRINTER TO TRUE
001890		       CALL 'GSWINAPI' USING WIN32API-PARMS
001900					     PRINTAPI-HANDLE
001910					     PRINTAPI-WRITEPRINTER-DATA
001920					     STUFF-TO-PRINT
001930					     WIN32API-D
001940					     WIN32API-E
001950					     WIN32API-F
001960*
001970		       MOVE "Write Printer API " TO WS-OPERATION-NAME
001980		       PERFORM 0101-DIAGNOSE-CALL
001990*
002000		       IF NOT WIN32API-FAILED
002010			 SET API-ENDPAGEPRINTER TO TRUE
002020			 CALL 'GSWINAPI' USING WIN32API-PARMS
002030					       PRINTAPI-HANDLE
002040					       WIN32API-B
002050					       WIN32API-C
002060					       WIN32API-D
002070					       WIN32API-E
002080					       WIN32API-F
002090*
002100			 MOVE "End Page Printer API " TO
002110			     WS-OPERATION-NAME
002120			 PERFORM 0101-DIAGNOSE-CALL
002130*
002140			 IF NOT WIN32API-FAILED
002150			   SET API-ENDDOCPRINTER TO TRUE
002160			   CALL 'GSWINAPI' USING WIN32API-PARMS
002170						 PRINTAPI-HANDLE
002180						 WIN32API-B
002190						 WIN32API-C
002200						 WIN32API-D
002210						 WIN32API-E
002220						 WIN32API-F
002230*
002240			   MOVE "End Doc  Printer API " TO
002250			       WS-OPERATION-NAME
002260			   PERFORM 0101-DIAGNOSE-CALL
002270*
002280			   IF NOT WIN32API-FAILED
002290			     SET API-CLOSEPRINTER TO TRUE
002300			     CALL 'GSWINAPI' USING WIN32API-PARMS
002310						   PRINTAPI-HANDLE
002320						   WIN32API-B
002330						   WIN32API-C
002340						   WIN32API-D
002350						   WIN32API-E
002360						   WIN32API-F
002370			     MOVE "Close Printer API " TO
002380				 WS-OPERATION-NAME
002390			     PERFORM 0101-DIAGNOSE-CALL
002400			   END-IF
002410			 END-IF
002420		       END-IF
002430		     END-IF
002440		   END-IF
002450		 END-IF
002460*
002470* 			:---------------------------------------
002480* ------------------------: PrintFile Function Demonstration
002490* 			:---------------------------------------
002500* 			:
002510	       WHEN TESTPRT-PRINT-A-FILE
002520		 MOVE LOW-VALUES TO PRTFILE-PARMS
002530* 			: Firse we use the GetFileOpenName api
002540* 			: to select the file to print
002550		 STRING 'Select a file to print.....'
002560		     LOW-VALUE DELIMITED SIZE INTO OPENSAVE-WINDOW-TITLE
002570		 STRING 'COB' DELIMITED SIZE LOW-VALUE
002580		     DELIMITED SIZE INTO OPENSAVE-DEFAULT-EXTENSION
002590		 MOVE TESTPRT-HWND TO OPENSAVE-HWNDOWNER
002600		 ADD OFN-EXPLORER
002610		     OFN-FILEMUSTEXIST
002620		     OFN-PATHMUSTEXIST
002630		     OFN-HIDEREADONLY
002640		     GIVING OPENSAVE-FLAGS
002650*
002660		 MOVE LOW-VALUE TO OPENSAVE-CUSTOMFILTER
002670				   OPENSAVE-FILENAME
002680		 MOVE LENGTH OF OPENSAVE-CUSTOMFILTER
002690		     TO OPENSAVE-LENGTH-CUSTFILTER
002700		 MOVE LENGTH OF OPENSAVE-FILESPEC
002710		     TO OPENSAVE-LENGTH-FILESPEC
002720		 MOVE LENGTH OF OPENSAVE-FILENAME
002730		     TO OPENSAVE-LENGTH-FILENAME
002740		 STRING '.\'
002750		     LOW-VALUE DELIMITED SIZE INTO OPENSAVE-INITIALDIR
002760		 MOVE 1 TO OPENSAVE-FILTER-INDEX
002770* 			: Load pairs of null-terminated strings
002780* 			: specifying the filter to use:
002790		 STRING
002800		     'Cobol Files (*.cob)' LOW-VALUE '*.cob' LOW-VALUE
002800		     'Cbl Files (*.cbl)' LOW-VALUE '*.cbl' LOW-VALUE
002810		     'Text Files (*.txt)' LOW-VALUE '*.TXT' LOW-VALUE
002820		     'All Files (*.*)' LOW-VALUE '*.*' LOW-VALUE
002830		     LOW-VALUE DELIMITED SIZE INTO OPENSAVE-FILTER
002840*
002850		 SET API-GETOPENFILENAME TO TRUE
002860		 CALL 'GSWINAPI' USING WIN32API-PARMS
002870				       OPENSAVE-PARMS
002880				       OPENSAVE-INITIALDIR
002890				       OPENSAVE-FILTER
002900				       OPENSAVE-CUSTOMFILTER
002910				       OPENSAVE-FILESPEC
002920				       OPENSAVE-FILENAME
002930		 MOVE "Get File Name API " TO WS-OPERATION-NAME
002940		 PERFORM 0101-DIAGNOSE-CALL
002950* 			: if that worked (and not canceled)
002960		 IF NOT WIN32API-FAILED AND OPENSAVE-FILESPEC > SPACE
002970* 			:
002980* 			: Prepare for PrintFile api call
002990		   MOVE OPENSAVE-FILESPEC TO PRTFILE-SOURCE-FILE-NAME
003000		   MOVE P-DEVICE TO PRTFILE-PRINTER-NAME
003010* 			: We load this just in case printer
003020* 			: name is not given, in which case
003030* 			: it will ask...
003040		   MOVE TESTPRT-HWND TO PRTFILE-DIALOG-HWND
003050		   MOVE OPENSAVE-FILENAME TO PRTFILE-DOCUMENT-NAME
003060		   SET PRTFILE-DATA-RAW TO TRUE
003070		   SET PRTFILE-CHECK-FINAL-EJECT TO TRUE
003080* 			: Just in case we are running under
003090* 			: client server we indicate where
003100* 			: source and destination are
003110		   SET PRTFILE-SOURCE-ON-CLIENT TO TRUE
003120* 			:---------------------------------------
003130* ------------------------: An example of how prepend/postpend
003140* 			: areas can be used.
003150* 			:---------------------------------------
003160* 			: See if any buttons are selected and
003170* 			: string escapes into pre/post buffers
003180		   MOVE 1 TO STRGPTR
003190		   IF 6LPI-ON
003200		     STRING 6-LPI DELIMITED SIZE
003210			 INTO PRTFILE-PREPEND-BUFFER
003220			 WITH POINTER STRGPTR
003230		   END-IF
003240		   IF 8LPI-ON
003250		     STRING 8-LPI DELIMITED SIZE
003260			 INTO PRTFILE-PREPEND-BUFFER
003270			 WITH POINTER STRGPTR
003280		   END-IF
003290*
003300		   IF PAGE-PORTRAIT-ON
003310		     STRING PORTRAIT DELIMITED SIZE
003320			 INTO PRTFILE-PREPEND-BUFFER
003330			 WITH POINTER STRGPTR
003340		   END-IF
003350		   IF PAGE-LANSCAPE-ON
003360		     STRING LANDSCAPE DELIMITED SIZE
003370			 INTO PRTFILE-PREPEND-BUFFER
003380			 WITH POINTER STRGPTR
003390		   END-IF
003400		   IF FONT-12-ON
003410		     STRING COURIER-12 DELIMITED SIZE
003420			 INTO PRTFILE-PREPEND-BUFFER
003430			 WITH POINTER STRGPTR
003440		   END-IF
003450		   IF FONT-14-ON
003460		     STRING HELVITICA-14 DELIMITED SIZE
003470			 INTO PRTFILE-PREPEND-BUFFER
003480			 WITH POINTER STRGPTR
003490		   END-IF
003500		   IF FONT-16-ON
003510		     STRING LINEPRINTER-16 DELIMITED SIZE
003520			 INTO PRTFILE-PREPEND-BUFFER
003530			 WITH POINTER STRGPTR
003540		   END-IF
003550* 			: Finally the do-it-all PrintFile call
003560		   SET FUNC-PRINTFILE TO TRUE
003570		   CALL 'GSWINAPI' USING WIN32API-PARMS
003580					 PRTFILE-PARMS
003590					 GS-DEVMODE-DATA
003600					 WIN32API-C
003610					 WIN32API-D
003620					 WIN32API-E
003630					 WIN32API-F
003640		   MOVE "Print File API " TO WS-OPERATION-NAME
003650		   PERFORM 0101-DIAGNOSE-CALL
003660		   MOVE PRTFILE-PRINTER-NAME TO P-DEVICE
003670		 END-IF
003680*
003690	     END-EVALUATE
003700*
003710	   END-PERFORM.
003720*
003730* ------------------------: Close the main before doing a STOP RUN
003740*
003750	   SET TESTMAIN-DO-CLOSE TO TRUE.
003760	   CALL 'GS' USING TESTMAIN-1
003770			   TESTMAIN-2
003780			   TESTMAIN-3
003790			   TESTMAIN-4.
003800	   STOP RUN.
003810*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
003820 0100-GS-UTILITY SECTION.
003830*
003840 0101-DIAGNOSE-CALL.
003850	   MOVE SPACE TO TESTPRT-MESSAGE-TEXT
003860	   IF WIN32API-FAILED
003870	     STRING WS-OPERATION-NAME DELIMITED '  '
003880		 ' FAILED' DELIMITED SIZE
003890		 WIN32API-ERROR-TEXT DELIMITED '   '
003900		 INTO TESTPRT-MESSAGE-TEXT
003910	     SET TESTPRT-MESSAGE-BAR-BEEP TO TRUE
003920	   ELSE
003930	     STRING WS-OPERATION-NAME DELIMITED '  '
003940		 ' Success' DELIMITED SIZE
003950		 INTO TESTPRT-MESSAGE-TEXT
003960	     SET TESTPRT-MESSAGE-BAR-SILENT TO TRUE
003970	   END-IF.
003980	   SET TESTPRT-DO-DISPLAY-AND-RETURN TO TRUE
003990	   CALL 'GS' USING TESTPRT-1
004000			   TESTPRT-2
004010			   TESTPRT-3
004020			   TESTPRT-4.
004030* -====-
004040 0102-INITIALIZE-GS.
004050* 			:---------------------------------------
004060* ------------------------: Open the application window (the
004070* 			: container for this application)
004080* 			:---------------------------------------
004090*
004100	   CALL 'GS' USING TESTMAIN-1
004110			   TESTMAIN-2
004120			   TESTMAIN-3
004130			   TESTMAIN-4.
